<template>
  <v-app-bar
      app
      color="primary"
      dark
  >

    <router-link to="/" tag="span" style="cursor: pointer">
      <div class="d-flex align-center text--white">
        <v-img
            alt="Logo"
            class="shrink mr-2"
            contain
            src="../assets/logo.png"
            transition="scale-transition"
            width="60"
        />

        <h1>Shop&Go</h1>
      </div>
    </router-link>

    <v-spacer></v-spacer>

    <div v-if="$store.getters.isLogged">
      <v-btn
          text
          elevation="0"
          color="white"
          v-for="item in menuItems"
          :key="item.title"
          :to="item.path"
          v-show="$store.getters.isAdmin === item.onlyAdmin || item.both"
      >
        <v-icon left>{{ item.icon }}</v-icon>
        {{ item.title }}
      </v-btn>
    </div>
    <div v-else>
      <v-btn
          text
          elevation="0"
          color="white"
          to="/registration"
      >
        <v-icon left>fas fa-user-plus</v-icon>
        Registrati
      </v-btn>

      <v-btn
          text
          elevation="0"
          color="white"
          to="/login"
      >
        <v-icon left>fas fa-sign-in-alt</v-icon>
        Accedi
      </v-btn>
    </div>

    <v-spacer />

    <div v-if="$store.getters.isLogged">
      <v-menu
          open-on-hover
          bottom
          offset-y
      >
        <template v-slot:activator="{ on, attrs }">
          <v-avatar color="black"
                    size="40"
                    v-bind="attrs"
                    v-on="on"
          >
            <span class="white--text text-h5"> {{ usersInitials }} </span>
          </v-avatar>
        </template>

        <v-list>
          <v-list-item>
            <v-list-item-title><span>Ciao {{ $store.getters.name }}!</span></v-list-item-title>
          </v-list-item>
          <v-list-item @click="logout">
            <v-list-item-title> <v-icon>fas fa-sign-out-alt</v-icon> <span> Esci</span></v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>

    </div>

  </v-app-bar>
</template>

<script>
export default {
  name: "Navbar",
  data () {
    return {
      menuItems: [
        { title: 'Supermercati', path: '/supermarkets', icon: 'fas fa-shopping-cart', onlyAdmin: true, both: false },
        { title: 'Utenti', path: '/users', icon: 'fas fa-users', onlyAdmin: true, both: false },
        { title: 'Categorie di prodotto', path: '/categories', icon: 'fas fa-shopping-basket', onlyAdmin: true, both: false },
        { title: 'Prodotti', path: '/products', icon: 'fas fa-utensils', onlyAdmin: false, both: true },
        { title: 'Carrello', path: '/cart', icon: 'fas fa-shopping-cart', onlyAdmin: false, both: false }
      ]
    }
  },
  computed: {
    usersInitials() {
      return this.$store.getters.name[0] + this.$store.getters.surname[0];
    }
  },
  methods: {
    logout() {
      this.$store.commit('logoutUser');
    }
  }
}
</script>

<style scoped>

</style>
